Index: trunk/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90	(revision 2528)
@@ -6,6 +6,8 @@
    !! History :  1.0  !  2005-01  (J. Chanut, A. Sellar)  Original code
    !!             -   !  2007-01  (D. Storkey) Update to use IOM module
-   !!             -   !  2007-07  (D. Storkey) add bdy_dta_bt
+   !!             -   !  2007-07  (D. Storkey) add bdy_dta_fla
    !!            3.0  !  2008-04  (NEMO team)  add in the reference version
+   !!            3.3  !  2010-09  (E.O'Dea) modifications for Shelf configurations 
+   !!            3.3  !  2010-09  (D.Storkey) add ice boundary conditions
    !!----------------------------------------------------------------------
 #if defined key_bdy
@@ -13,7 +15,6 @@
    !!   'key_bdy'                     Unstructured Open Boundary Conditions
    !!----------------------------------------------------------------------
-   !!   bdy_dta    : read u, v, t, s data along open boundaries
-   !!   bdy_dta_bt : read depth-mean velocities and elevation along open
-   !!                boundaries        
+   !!   bdy_dta_frs    : read u, v, t, s data along open boundaries
+   !!   bdy_dta_fla : read depth-mean velocities and elevation along open boundaries        
    !!----------------------------------------------------------------------
    USE oce             ! ocean dynamics and tracers
@@ -25,38 +26,46 @@
    USE ioipsl
    USE in_out_manager  ! I/O logical units
+#if defined key_lim2
+   USE ice_2
+#endif
 
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC   bdy_dta      ! routines called by step.F90
-   PUBLIC   bdy_dta_bt 
-
-   INTEGER ::   numbdyt, numbdyu, numbdyv                      !: logical units for T-, U-, & V-points data file, resp.
-   INTEGER ::   ntimes_bdy                                     !: exact number of time dumps in data files
-   INTEGER ::   nbdy_b, nbdy_a                                 !: record of bdy data file for before and after model time step
-   INTEGER ::   numbdyt_bt, numbdyu_bt, numbdyv_bt             !: logical unit for T-, U- & V-points data file, resp.
-   INTEGER ::   ntimes_bdy_bt                                  !: exact number of time dumps in data files
-   INTEGER ::   nbdy_b_bt, nbdy_a_bt                           !: record of bdy data file for before and after model time step
-
-   INTEGER, DIMENSION (jpbtime) ::   istep, istep_bt           !: time array in seconds in each data file
-
-   REAL(wp) ::  zoffset                                        !: time offset between time origin in file & start time of model run
-
-   REAL(wp), DIMENSION(jpbdim,jpk,2) ::   tbdydta, sbdydta     !: time interpolated values of T and S bdy data   
-   REAL(wp), DIMENSION(jpbdim,jpk,2) ::   ubdydta, vbdydta     !: time interpolated values of U and V bdy data 
-   REAL(wp), DIMENSION(jpbdim,2)     ::   ubtbdydta, vbtbdydta !: Arrays used for time interpolation of bdy data   
-   REAL(wp), DIMENSION(jpbdim,2)     ::   sshbdydta            !: bdy data of ssh
+   PUBLIC   bdy_dta_frs      ! routines called by step.F90
+   PUBLIC   bdy_dta_fla 
+
+   INTEGER ::   numbdyt, numbdyu, numbdyv                      ! logical units for T-, U-, & V-points data file, resp.
+   INTEGER ::   ntimes_bdy                                     ! exact number of time dumps in data files
+   INTEGER ::   nbdy_b, nbdy_a                                 ! record of bdy data file for before and after time step
+   INTEGER ::   numbdyt_bt, numbdyu_bt, numbdyv_bt             ! logical unit for T-, U- & V-points data file, resp.
+   INTEGER ::   ntimes_bdy_bt                                  ! exact number of time dumps in data files
+   INTEGER ::   nbdy_b_bt, nbdy_a_bt                           ! record of bdy data file for before and after time step
+
+   INTEGER, DIMENSION (jpbtime) ::   istep, istep_bt           ! time array in seconds in each data file
+
+   REAL(wp) ::  zoffset                                        ! time offset between time origin in file & start time of model run
+
+   REAL(wp), DIMENSION(jpbdim,jpk,2) ::   tbdydta, sbdydta     ! time interpolated values of T and S bdy data   
+   REAL(wp), DIMENSION(jpbdim,jpk,2) ::   ubdydta, vbdydta     ! time interpolated values of U and V bdy data 
+   REAL(wp), DIMENSION(jpbdim,2)     ::   ubtbdydta, vbtbdydta ! Arrays used for time interpolation of bdy data   
+   REAL(wp), DIMENSION(jpbdim,2)     ::   sshbdydta            ! bdy data of ssh
+
+#if defined key_lim2
+   REAL(wp), DIMENSION(jpbdim,2)     ::   frld_bdydta          ! }
+   REAL(wp), DIMENSION(jpbdim,2)     ::   hicif_bdydta         ! } Arrays used for time interp. of ice bdy data 
+   REAL(wp), DIMENSION(jpbdim,2)     ::   hsnif_bdydta         ! }
+#endif
 
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.0 , LOCEAN-IPSL (2008) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
 
-   SUBROUTINE bdy_dta( kt )
+   SUBROUTINE bdy_dta_frs( kt )
       !!----------------------------------------------------------------------
-      !!                   ***  SUBROUTINE bdy_dta  ***
+      !!                   ***  SUBROUTINE bdy_dta_frs  ***
       !!                    
       !! ** Purpose :   Read unstructured boundary data for FRS condition.
@@ -67,5 +76,5 @@
       !!                the file. If so read it in. Time interpolate.
       !!----------------------------------------------------------------------
-      INTEGER, INTENT( in ) ::   kt                             ! ocean time-step index (for timesplitting option, otherwise zero)
+      INTEGER, INTENT( in ) ::   kt   ! ocean time-step index (for timesplitting option, otherwise zero)
       !!
       CHARACTER(LEN=80), DIMENSION(3) ::   clfile               ! names of input files
@@ -79,5 +88,5 @@
       INTEGER ::   itimer, totime
       INTEGER ::   ii, ij                                       ! array addresses
-      INTEGER ::   ipi, ipj, ipk, inum                          ! temporary integers (NetCDF read)
+      INTEGER ::   ipi, ipj, ipk, inum                          ! local integers (NetCDF read)
       INTEGER ::   iyear0, imonth0, iday0
       INTEGER ::   ihours0, iminutes0, isec0
@@ -91,6 +100,7 @@
       !!---------------------------------------------------------------------------
 
-      IF( ln_bdy_dyn_frs .OR. ln_bdy_tra_frs ) THEN  ! If these are both false then this routine 
-                                                     ! does nothing.
+
+      IF( ln_dyn_frs .OR. ln_tra_frs    &
+         &               .OR. ln_ice_frs ) THEN  ! If these are both false then this routine does nothing
 
       ! -------------------- !
@@ -102,5 +112,6 @@
       ! Some time variables for monthly climatological forcing:
       ! *******************************************************
- !!gm  here  use directely daymod variables
+
+!!gm  here  use directely daymod calendar variables
  
       iman = INT( raamo )      ! Number of months in a year
@@ -121,6 +132,6 @@
          !                                             !-------------------!
          istep(:) = 0
-         nbdy_b    = 0
-         nbdy_a    = 0
+         nbdy_b   = 0
+         nbdy_a   = 0
 
          ! Get time information from bdy data file
@@ -128,12 +139,12 @@
 
          IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*)    'bdy_dta : Initialize unstructured boundary data'
+         IF(lwp) WRITE(numout,*)    'bdy_dta_frs : Initialize unstructured boundary data'
          IF(lwp) WRITE(numout,*)    '~~~~~~~' 
 
-         IF     ( nbdy_dta == 0 ) THEN
+         IF     ( nn_dtactl == 0 ) THEN
             !
             IF(lwp) WRITE(numout,*) '          Bdy data are taken from initial conditions'
             !
-         ELSEIF (nbdy_dta == 1) THEN
+         ELSEIF (nn_dtactl == 1) THEN
             !
             IF(lwp) WRITE(numout,*) '          Bdy data are read in netcdf files'
@@ -144,16 +155,14 @@
             !                                                 ! necessary time dumps in file are included
             !
-            clfile(1) = filbdy_data_T
-            clfile(2) = filbdy_data_U
-            clfile(3) = filbdy_data_V
+            clfile(1) = cn_dta_frs_T
+            clfile(2) = cn_dta_frs_U
+            clfile(3) = cn_dta_frs_V
             !                                                  
             ! how many files are we to read in?
             igrd_start = 1
             igrd_end   = 3
-            IF(.NOT. ln_bdy_tra_frs .AND. .NOT. ln_bdy_ice_frs) THEN
-               ! No T-grid file.
+            IF(.NOT. ln_tra_frs .AND. .NOT. ln_ice_frs) THEN       ! No T-grid file.
                igrd_start = 2
-            ELSEIF ( .NOT. ln_bdy_dyn_frs ) THEN
-               ! No U-grid or V-grid file.
+            ELSEIF ( .NOT. ln_dyn_frs ) THEN                           ! No U-grid or V-grid file.
                igrd_end   = 1         
             ENDIF
@@ -165,10 +174,7 @@
 
                SELECT CASE( igrd )
-                  CASE (1) 
-                     numbdyt = inum
-                  CASE (2) 
-                     numbdyu = inum
-                  CASE (3) 
-                     numbdyv = inum
+                  CASE (1)   ;   numbdyt = inum
+                  CASE (2)   ;   numbdyu = inum
+                  CASE (3)   ;   numbdyv = inum
                END SELECT
 
@@ -196,5 +202,5 @@
                IF(lwp) WRITE(numout,*) 'offset: ',zoffset
                IF(lwp) WRITE(numout,*) 'totime: ',totime
-               IF(lwp) WRITE(numout,*) 'zstepr: ',zstepr
+               IF(lwp) WRITE(numout,*) 'zstepr: ',zstepr(1:ntimes_bdy)
 
                ! Check that there are not too many times in the file. 
@@ -205,11 +211,10 @@
 
                ! Check that time array increases:
-        
                it = 1
-               DO WHILE( zstepr(it+1) > zstepr(it) .AND. it /= ntimes_bdy - 1 )
-                 it = it + 1
+               DO WHILE( zstepr(it+1) > zstepr(it) .AND. it /= ntimes_bdy - 1 ) 
+                  it = it + 1
                END DO
-
-               IF( it.NE.ntimes_bdy-1 .AND. ntimes_bdy > 1 ) THEN
+               !
+               IF( it /= ntimes_bdy-1 .AND. ntimes_bdy > 1 ) THEN
                      WRITE(ctmp1,*) 'Check file: ', clfile(igrd)
                      CALL ctl_stop( 'Time array in unstructured boundary data files',   &
@@ -227,17 +232,21 @@
                END IF
                !
-               IF    ( igrd == 1 ) THEN
-                 ntimes_bdyt = ntimes_bdy
-                 zoffsett = zoffset
-                 istept(:) = INT( zstepr(:) + zoffset )
-               ELSEIF(igrd == 2 ) THEN
-                 ntimes_bdyu = ntimes_bdy
-                 zoffsetu = zoffset
-                 istepu(:) = INT( zstepr(:) + zoffset )
-               ELSEIF(igrd == 3 ) THEN
-                 ntimes_bdyv = ntimes_bdy
-                 zoffsetv = zoffset
-                 istepv(:) = INT( zstepr(:) + zoffset )
-               ENDIF
+               SELECT CASE( igrd )
+                  CASE (1)
+                    ntimes_bdyt = ntimes_bdy
+                    zoffsett = zoffset
+                    istept(:) = INT( zstepr(:) + zoffset )
+                    numbdyt = inum
+                  CASE (2)
+                    ntimes_bdyu = ntimes_bdy
+                    zoffsetu = zoffset
+                    istepu(:) = INT( zstepr(:) + zoffset )
+                    numbdyu = inum
+                  CASE (3)
+                    ntimes_bdyv = ntimes_bdy
+                    zoffsetv = zoffset
+                    istepv(:) = INT( zstepr(:) + zoffset )
+                    numbdyv = inum
+               END SELECT
                !
             END DO                                         ! end loop over T, U & V grid 
@@ -259,19 +268,17 @@
             ENDIF
 
-            IF( igrd_start == 1 ) THEN
-               istep(:) = istept(:)
-            ELSE
-               istep(:) = istepu(:)
+            IF( igrd_start == 1 ) THEN   ;   istep(:) = istept(:)
+            ELSE                         ;   istep(:) = istepu(:)
             ENDIF
 
             ! Check number of time dumps:              
-            IF( ntimes_bdy == 1 .AND. .NOT. ln_bdy_clim ) THEN
+            IF( ntimes_bdy == 1 .AND. .NOT. ln_clim ) THEN
               CALL ctl_stop( 'There is only one time dump in data files',   &
-                 &           'Choose ln_bdy_clim=.true. in namelist for constant bdy forcing.' )
+                 &           'Choose ln_clim=.true. in namelist for constant bdy forcing.' )
             ENDIF
 
-            IF( ln_bdy_clim ) THEN
+            IF( ln_clim ) THEN
               IF( ntimes_bdy /= 1 .AND. ntimes_bdy /= 12 ) THEN
-                 CALL ctl_stop( 'For climatological boundary forcing (ln_bdy_clim=.true.),',   &
+                 CALL ctl_stop( 'For climatological boundary forcing (ln_clim=.true.),',   &
                     &           'bdy data files must contain 1 or 12 time dumps.' )
               ELSEIF( ntimes_bdy ==  1 ) THEN
@@ -287,56 +294,66 @@
             it = 1
             DO WHILE( istep(it+1) <= 0 .AND. it <= ntimes_bdy - 1 )
-              it = it + 1
+               it = it + 1
             END DO
             nbdy_b = it
             !
-            WRITE(numout,*) 'Time offset is ',zoffset
-            WRITE(numout,*) 'First record to read is ',nbdy_b
-
-         ENDIF ! endif (nbdy_dta == 1)
-
-
-         ! 1.2  Read first record in file if necessary (ie if nbdy_dta == 1)
+            IF(lwp) WRITE(numout,*) 'Time offset is ',zoffset
+            IF(lwp) WRITE(numout,*) 'First record to read is ',nbdy_b
+
+         ENDIF ! endif (nn_dtactl == 1)
+
+
+         ! 1.2  Read first record in file if necessary (ie if nn_dtactl == 1)
          ! *****************************************************************
 
-         IF( nbdy_dta == 0) THEN      ! boundary data arrays are filled with initial conditions
+         IF( nn_dtactl == 0 ) THEN      ! boundary data arrays are filled with initial conditions
             !
-            IF (ln_bdy_tra_frs) THEN
-              igrd = 1            ! T-points data 
-              DO ib = 1, nblen(igrd)
-                ii = nbi(ib,igrd)
-                ij = nbj(ib,igrd)
-                DO ik = 1, jpkm1
-                  tbdy(ib,ik) = tn(ii, ij, ik)
-                  sbdy(ib,ik) = sn(ii, ij, ik)
-                ENDDO
-              END DO
+            IF (ln_tra_frs) THEN
+               igrd = 1            ! T-points data 
+               DO ib = 1, nblen(igrd)
+                  ii = nbi(ib,igrd)
+                  ij = nbj(ib,igrd)
+                  DO ik = 1, jpkm1
+                     tbdy(ib,ik) = tn(ii,ij,ik)
+                     sbdy(ib,ik) = sn(ii,ij,ik)
+                  END DO
+               END DO
             ENDIF
 
-            IF(ln_bdy_dyn_frs) THEN
-              igrd = 2            ! U-points data 
-              DO ib = 1, nblen(igrd)
-                ii = nbi(ib,igrd)
-                ij = nbj(ib,igrd)
-                DO ik = 1, jpkm1
-                  ubdy(ib,ik) = un(ii, ij, ik)
-                ENDDO
-              END DO
-
-              igrd = 3            ! V-points data 
-              DO ib = 1, nblen(igrd)            
-                ii = nbi(ib,igrd)
-                ij = nbj(ib,igrd)
-                DO ik = 1, jpkm1
-                  vbdy(ib,ik) = vn(ii, ij, ik)
-                ENDDO
-              END DO
+            IF(ln_dyn_frs) THEN
+               igrd = 2            ! U-points data 
+               DO ib = 1, nblen(igrd)
+                  ii = nbi(ib,igrd)
+                  ij = nbj(ib,igrd)
+                  DO ik = 1, jpkm1
+                     ubdy(ib,ik) = un(ii, ij, ik)
+                  END DO
+               END DO
+               !
+               igrd = 3            ! V-points data 
+               DO ib = 1, nblen(igrd)            
+                  ii = nbi(ib,igrd)
+                  ij = nbj(ib,igrd)
+                  DO ik = 1, jpkm1
+                     vbdy(ib,ik) = vn(ii, ij, ik)
+                  END DO
+               END DO
             ENDIF
             !
-         ELSEIF( nbdy_dta == 1 ) THEN    ! Set first record in the climatological case:   
+#if defined key_lim2
+            IF( ln_ice_frs ) THEN
+               igrd = 1            ! T-points data
+               DO ib = 1, nblen(igrd)
+                  frld_bdy (ib) =  frld(nbi(ib,igrd), nbj(ib,igrd))
+                  hicif_bdy(ib) = hicif(nbi(ib,igrd), nbj(ib,igrd))
+                  hsnif_bdy(ib) = hsnif(nbi(ib,igrd), nbj(ib,igrd))
+               END DO
+            ENDIF
+#endif
+         ELSEIF( nn_dtactl == 1 ) THEN    ! Set first record in the climatological case:   
             !
-            IF( ln_bdy_clim .AND. ntimes_bdy == 1 ) THEN
+            IF( ln_clim .AND. ntimes_bdy == 1 ) THEN
                nbdy_a = 1
-            ELSEIF( ln_bdy_clim .AND. ntimes_bdy == iman ) THEN
+            ELSEIF( ln_clim .AND. ntimes_bdy == iman ) THEN
                nbdy_b = 0
                nbdy_a = imois
@@ -351,5 +368,6 @@
             ipi  = nblendta(igrd)
 
-            IF(ln_bdy_tra_frs) THEN
+            IF(ln_tra_frs) THEN
+               !
                igrd = 1                                           ! Temperature
                IF( nblendta(igrd) <=  0 ) THEN 
@@ -357,8 +375,8 @@
                   nblendta(igrd) = iom_file(numbdyt)%dimsz(1,idvar)
                ENDIF
-               WRITE(numout,*) 'Dim size for votemper is ', nblendta(igrd)
+               IF(lwp) WRITE(numout,*) 'Dim size for votemper is ', nblendta(igrd)
                ipi = nblendta(igrd)
                CALL iom_get ( numbdyt, jpdom_unknown, 'votemper', zdta(1:ipi,1:ipj,1:ipk), nbdy_a )
-
+               !
                DO ib = 1, nblen(igrd)
                   DO ik = 1, jpkm1
@@ -372,8 +390,8 @@
                   nblendta(igrd) = iom_file(numbdyt)%dimsz(1,idvar)
                ENDIF
-               WRITE(numout,*) 'Dim size for vosaline is ', nblendta(igrd)
+               IF(lwp) WRITE(numout,*) 'Dim size for vosaline is ', nblendta(igrd)
                ipi = nblendta(igrd)
                CALL iom_get ( numbdyt, jpdom_unknown, 'vosaline', zdta(1:ipi,1:ipj,1:ipk), nbdy_a )
-
+               !
                DO ib = 1, nblen(igrd)
                   DO ik = 1, jpkm1
@@ -381,8 +399,8 @@
                   END DO
                END DO
-            ENDIF  ! ln_bdy_tra_frs
+            ENDIF  ! ln_tra_frs
  
-            IF(ln_bdy_dyn_frs) THEN
-
+            IF( ln_dyn_frs ) THEN
+               !
                igrd = 2                                           ! u-velocity
                IF ( nblendta(igrd) .le. 0 ) THEN 
@@ -390,5 +408,5 @@
                  nblendta(igrd) = iom_file(numbdyu)%dimsz(1,idvar)
                ENDIF
-               WRITE(numout,*) 'Dim size for vozocrtx is ', nblendta(igrd)
+               IF(lwp) WRITE(numout,*) 'Dim size for vozocrtx is ', nblendta(igrd)
                ipi = nblendta(igrd)
                CALL iom_get ( numbdyu, jpdom_unknown,'vozocrtx',zdta(1:ipi,1:ipj,1:ipk),nbdy_a )
@@ -404,5 +422,5 @@
                  nblendta(igrd) = iom_file(numbdyv)%dimsz(1,idvar)
                ENDIF
-               WRITE(numout,*) 'Dim size for vomecrty is ', nblendta(igrd)
+               IF(lwp) WRITE(numout,*) 'Dim size for vomecrty is ', nblendta(igrd)
                ipi = nblendta(igrd)
                CALL iom_get ( numbdyv, jpdom_unknown,'vomecrty',zdta(1:ipi,1:ipj,1:ipk),nbdy_a )
@@ -412,95 +430,144 @@
                   END DO
                END DO
-            ENDIF ! ln_bdy_dyn_frs
-
-
-            IF ((.NOT.ln_bdy_clim) .AND. (istep(1) > 0)) THEN
-               ! First data time is after start of run
-               ! Put first value in both time levels
-               nbdy_b = nbdy_a
-               IF(ln_bdy_tra_frs) THEN
+            ENDIF ! ln_dyn_frs
+
+#if defined key_lim2
+            IF( ln_ice_frs ) THEN
+              !
+              igrd=1                                              ! leads fraction
+              IF(lwp) WRITE(numout,*) 'Dim size for ildsconc is ',nblendta(igrd)
+              ipi=nblendta(igrd)
+              CALL iom_get ( numbdyt, jpdom_unknown,'ildsconc',zdta(1:ipi,:,1),nbdy_a )
+              DO ib=1, nblen(igrd)
+                frld_bdydta(ib,2) =  zdta(nbmap(ib,igrd),1,1)
+              END DO
+              !
+              igrd=1                                              ! ice thickness
+              IF(lwp) WRITE(numout,*) 'Dim size for iicethic is ',nblendta(igrd)
+              ipi=nblendta(igrd)
+              CALL iom_get ( numbdyt, jpdom_unknown,'iicethic',zdta(1:ipi,:,1),nbdy_a )
+              DO ib=1, nblen(igrd)
+                hicif_bdydta(ib,2) =  zdta(nbmap(ib,igrd),1,1)
+              END DO
+              !
+              igrd=1                                              ! snow thickness
+              IF(lwp) WRITE(numout,*) 'Dim size for isnowthi is ',nblendta(igrd)
+              ipi=nblendta(igrd)
+              CALL iom_get ( numbdyt, jpdom_unknown,'isnowthi',zdta(1:ipi,:,1),nbdy_a )
+              DO ib=1, nblen(igrd)
+                hsnif_bdydta(ib,2) =  zdta(nbmap(ib,igrd),1,1)
+              END DO
+            ENDIF ! just if ln_ice_frs is set
+#endif
+
+            IF( .NOT.ln_clim .AND. istep(1) > 0 ) THEN     ! First data time is after start of run
+               nbdy_b = nbdy_a                                 ! Put first value in both time levels
+               IF( ln_tra_frs ) THEN
                  tbdydta(:,:,1) = tbdydta(:,:,2)
                  sbdydta(:,:,1) = sbdydta(:,:,2)
                ENDIF
-               IF(ln_bdy_dyn_frs) THEN
+               IF( ln_dyn_frs ) THEN
                  ubdydta(:,:,1) = ubdydta(:,:,2)
                  vbdydta(:,:,1) = vbdydta(:,:,2)
                ENDIF
+#if defined key_lim2
+               IF( ln_ice_frs ) THEN
+                  frld_bdydta (:,1) =  frld_bdydta(:,2)
+                  hicif_bdydta(:,1) = hicif_bdydta(:,2)
+                  hsnif_bdydta(:,1) = hsnif_bdydta(:,2)
+               ENDIF
+#endif
             END IF
-
-         END IF ! nbdy_dta == 0/1
+            !
+         END IF   ! nn_dtactl == 0/1
  
          ! In the case of constant boundary forcing fill bdy arrays once for all
-         IF ((ln_bdy_clim).AND.(ntimes_bdy==1)) THEN
-            IF(ln_bdy_tra_frs) THEN
-              tbdy  (:,:) = tbdydta  (:,:,2)
-              sbdy  (:,:) = sbdydta  (:,:,2)
+         IF( ln_clim .AND. ntimes_bdy == 1 ) THEN
+            IF( ln_tra_frs ) THEN
+               tbdy  (:,:) = tbdydta  (:,:,2)
+               sbdy  (:,:) = sbdydta  (:,:,2)
             ENDIF
-            IF(ln_bdy_dyn_frs) THEN
-              ubdy  (:,:) = ubdydta  (:,:,2)
-              vbdy  (:,:) = vbdydta  (:,:,2)
+            IF( ln_dyn_frs) THEN
+               ubdy  (:,:) = ubdydta  (:,:,2)
+               vbdy  (:,:) = vbdydta  (:,:,2)
             ENDIF
-
-            IF(ln_bdy_tra_frs .or. ln_bdy_ice_frs) CALL iom_close( numbdyt )
-            IF(ln_bdy_dyn_frs) CALL iom_close( numbdyu )
-            IF(ln_bdy_dyn_frs) CALL iom_close( numbdyv )
+#if defined key_lim2
+            IF( ln_ice_frs ) THEN
+               frld_bdy (:) = frld_bdydta (:,2)
+               hicif_bdy(:) = hicif_bdydta(:,2)
+               hsnif_bdy(:) = hsnif_bdydta(:,2)
+            ENDIF
+#endif
+
+            IF( ln_tra_frs .OR. ln_ice_frs) CALL iom_close( numbdyt )
+            IF( ln_dyn_frs                    ) CALL iom_close( numbdyu )
+            IF( ln_dyn_frs                    ) CALL iom_close( numbdyv )
          END IF
-
+         !
       ENDIF                                            ! End if nit000
 
 
       !                                                !---------------------!
-      !                                                !  at each time step  !
-      !                                                !---------------------!
-
-      IF( nbdy_dta == 1 .AND. ntimes_bdy > 1 ) THEN 
-         !
+      IF( nn_dtactl == 1 .AND. ntimes_bdy > 1 ) THEN    !  at each time step  !
+         !                                             !---------------------!
          ! Read one more record if necessary
          !**********************************
 
-        IF( ln_bdy_clim .AND. imois /= nbdy_b ) THEN      ! remember that nbdy_b=0 for kt=nit000
-           nbdy_b = imois
-           nbdy_a = imois + 1
-           nbdy_b = MOD( nbdy_b, iman )   ;   IF( nbdy_b == 0 ) nbdy_b = iman
-           nbdy_a = MOD( nbdy_a, iman )   ;   IF( nbdy_a == 0 ) nbdy_a = iman
-           lect=.true.
-        ELSEIF( .NOT.ln_bdy_clim .AND. itimer >= istep(nbdy_a) ) THEN
-
-           IF ( nbdy_a < ntimes_bdy ) THEN
-              nbdy_b = nbdy_a
-              nbdy_a = nbdy_a + 1
-              lect  =.true.
-           ELSE
-              ! We have reached the end of the file
-              ! put the last data time into both time levels
-              nbdy_b = nbdy_a
-              IF(ln_bdy_tra_frs) THEN
-                tbdydta(:,:,1) =  tbdydta(:,:,2)
-                sbdydta(:,:,1) =  sbdydta(:,:,2)
-              ENDIF
-              IF(ln_bdy_dyn_frs) THEN
-                ubdydta(:,:,1) =  ubdydta(:,:,2)
-                vbdydta(:,:,1) =  vbdydta(:,:,2)
-              ENDIF
+         IF( ln_clim .AND. imois /= nbdy_b ) THEN      ! remember that nbdy_b=0 for kt=nit000
+            nbdy_b = imois
+            nbdy_a = imois + 1
+            nbdy_b = MOD( nbdy_b, iman )   ;   IF( nbdy_b == 0 ) nbdy_b = iman
+            nbdy_a = MOD( nbdy_a, iman )   ;   IF( nbdy_a == 0 ) nbdy_a = iman
+            lect=.true.
+         ELSEIF( .NOT.ln_clim .AND. itimer >= istep(nbdy_a) ) THEN
+
+            IF( nbdy_a < ntimes_bdy ) THEN
+               nbdy_b = nbdy_a
+               nbdy_a = nbdy_a + 1
+               lect  =.true.
+            ELSE
+               ! We have reached the end of the file
+               ! put the last data time into both time levels
+               nbdy_b = nbdy_a
+               IF(ln_tra_frs) THEN
+                  tbdydta(:,:,1) =  tbdydta(:,:,2)
+                  sbdydta(:,:,1) =  sbdydta(:,:,2)
+               ENDIF
+               IF(ln_dyn_frs) THEN
+                  ubdydta(:,:,1) =  ubdydta(:,:,2)
+                  vbdydta(:,:,1) =  vbdydta(:,:,2)
+               ENDIF
+#if defined key_lim2
+               IF(ln_ice_frs) THEN
+                  frld_bdydta (:,1) =  frld_bdydta (:,2)
+                  hicif_bdydta(:,1) =  hicif_bdydta(:,2)
+                  hsnif_bdydta(:,1) =  hsnif_bdydta(:,2)
+               ENDIF
+#endif
             END IF ! nbdy_a < ntimes_bdy
-
+            !
         END IF
          
-        IF( lect ) THEN
-           ! Swap arrays
-           IF(ln_bdy_tra_frs) THEN
+        IF( lect ) THEN           ! Swap arrays
+           IF( ln_tra_frs ) THEN
              tbdydta(:,:,1) =  tbdydta(:,:,2)
              sbdydta(:,:,1) =  sbdydta(:,:,2)
            ENDIF
-           IF(ln_bdy_dyn_frs) THEN
+           IF( ln_dyn_frs ) THEN
              ubdydta(:,:,1) =  ubdydta(:,:,2)
              vbdydta(:,:,1) =  vbdydta(:,:,2)
            ENDIF
- 
+#if defined key_lim2
+           IF( ln_ice_frs ) THEN
+             frld_bdydta (:,1) =  frld_bdydta (:,2)
+             hicif_bdydta(:,1) =  hicif_bdydta(:,2)
+             hsnif_bdydta(:,1) =  hsnif_bdydta(:,2)
+           ENDIF
+#endif 
            ! read another set
            ipj  = 1
            ipk  = jpk
 
-           IF(ln_bdy_tra_frs) THEN
+           IF( ln_tra_frs ) THEN
               ! 
               igrd = 1                                   ! temperature
@@ -521,7 +588,7 @@
                  END DO
               END DO
-           ENDIF ! ln_bdy_tra_frs
-
-           IF(ln_bdy_dyn_frs) THEN
+           ENDIF ! ln_tra_frs
+
+           IF(ln_dyn_frs) THEN
               !
               igrd = 2                                   ! u-velocity
@@ -542,10 +609,35 @@
                  END DO
               END DO
-           ENDIF ! ln_bdy_dyn_frs
-
+           ENDIF ! ln_dyn_frs
            !
-           IF(lwp) WRITE(numout,*) 'bdy_dta : first record file used nbdy_b ',nbdy_b
+#if defined key_lim2
+           IF(ln_ice_frs) THEN
+             !
+             igrd = 1                                    ! ice concentration
+             ipi=nblendta(igrd)
+             CALL iom_get ( numbdyt, jpdom_unknown,'ildsconc',zdta(1:ipi,:,1),nbdy_a )
+             DO ib=1, nblen(igrd)
+               frld_bdydta(ib,2) =  zdta( nbmap(ib,igrd), 1, 1 )
+             END DO
+             !
+             igrd=1                                      ! ice thickness
+             ipi=nblendta(igrd)
+             CALL iom_get ( numbdyt, jpdom_unknown,'iicethic',zdta(1:ipi,:,1),nbdy_a )
+             DO ib=1, nblen(igrd)
+               hicif_bdydta(ib,2) =  zdta( nbmap(ib,igrd), 1, 1 )
+             END DO
+             !
+             igrd=1                                      ! snow thickness
+             ipi=nblendta(igrd)
+             CALL iom_get ( numbdyt, jpdom_unknown,'isnowthi',zdta(1:ipi,:,1),nbdy_a )
+             DO ib=1, nblen(igrd)
+               hsnif_bdydta(ib,2) =  zdta( nbmap(ib,igrd), 1, 1 )
+             END DO
+           ENDIF ! ln_ice_frs
+#endif
+           !
+           IF(lwp) WRITE(numout,*) 'bdy_dta_frs : first record file used nbdy_b ',nbdy_b
            IF(lwp) WRITE(numout,*) '~~~~~~~~  last  record file used nbdy_a ',nbdy_a
-           IF (.NOT.ln_bdy_clim) THEN
+           IF (.NOT.ln_clim) THEN
               IF(lwp) WRITE(numout,*) 'first  record time (s): ', istep(nbdy_b)
               IF(lwp) WRITE(numout,*) 'model time (s)        : ', itimer
@@ -559,9 +651,11 @@
        ! ********************
        ! 
-       IF( ln_bdy_clim ) THEN   ;   zxy = REAL( nday                  , wp ) / REAL( nmonth_len(nbdy_b), wp ) + 0.5 - i15
-       ELSE                     ;   zxy = REAL( istep(nbdy_b) - itimer, wp ) / REAL( istep(nbdy_b) - istep(nbdy_a), wp )
+       IF( ln_clim ) THEN   ;   zxy = REAL( nday                   ) / REAL( nmonth_len(nbdy_b) ) + 0.5 - i15
+       ELSEIF( istep(nbdy_b) == istep(nbdy_a) ) THEN 
+                                    zxy = 0.0_wp
+       ELSE                     ;   zxy = REAL( istep(nbdy_b) - itimer ) / REAL( istep(nbdy_b) - istep(nbdy_a) )
        END IF
 
-          IF(ln_bdy_tra_frs) THEN
+          IF(ln_tra_frs) THEN
              igrd = 1                                   ! temperature & salinity
              DO ib = 1, nblen(igrd)
@@ -573,5 +667,5 @@
           ENDIF
 
-          IF(ln_bdy_dyn_frs) THEN
+          IF(ln_dyn_frs) THEN
              igrd = 2                                   ! u-velocity
              DO ib = 1, nblen(igrd)
@@ -589,5 +683,16 @@
           ENDIF
 
-      END IF                       !end if ((nbdy_dta==1).AND.(ntimes_bdy>1))
+#if defined key_lim2
+          IF(ln_ice_frs) THEN
+            igrd=1
+            DO ib=1, nblen(igrd)
+               frld_bdy(ib) = zxy *  frld_bdydta(ib,2) + (1.-zxy) *  frld_bdydta(ib,1)
+              hicif_bdy(ib) = zxy * hicif_bdydta(ib,2) + (1.-zxy) * hicif_bdydta(ib,1)
+              hsnif_bdy(ib) = zxy * hsnif_bdydta(ib,2) + (1.-zxy) * hsnif_bdydta(ib,1)
+            END DO
+          ENDIF ! just if ln_ice_frs is true
+#endif
+
+      END IF                       !end if ((nn_dtactl==1).AND.(ntimes_bdy>1))
     
 
